package com.example.aspdemo;

import android.util.Log;

import androidx.annotation.NonNull;

import okhttp3.Dns;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Objects;

public class CustomDns implements Dns {
    private static HashMap<String, List<InetAddress>> sHostMaps = new HashMap<>();
    private static boolean sIsUseCustomDns = false;

    static {
        try {
            sHostMaps.put("ecd.cn-shenzhen.aliyuncs.com", Collections.singletonList(InetAddress.getByName("100.64.28.252")));
            sHostMaps.put("appstream-center.cn-hangzhou.aliyuncs.com", Collections.singletonList(InetAddress.getByName("100.64.28.252")));
            sHostMaps.put("appstream-center.cn-shanghai.aliyuncs.com", Collections.singletonList(InetAddress.getByName("100.64.28.252")));
            sHostMaps.put("appstream-center.cn-shenzhen.aliyuncs.com", Collections.singletonList(InetAddress.getByName("100.64.28.252")));
            sHostMaps.put("appstream.cn-hangzhou.aliyuncs.com", Collections.singletonList(InetAddress.getByName("100.64.28.252")));
            sHostMaps.put("metaspace-test-0.cn-hangzhou.aliyuncs.com", Collections.singletonList(InetAddress.getByName("100.64.28.252")));
            sHostMaps.put("ecd.cn-hangzhou.aliyuncs.com", Collections.singletonList(InetAddress.getByName("100.64.28.252")));
            sHostMaps.put("ecd.cn-shanghai.aliyuncs.com", Collections.singletonList(InetAddress.getByName("100.64.28.252")));
            sHostMaps.put("ecd.ap-southeast-1.aliyuncs.com", Collections.singletonList(InetAddress.getByName("100.64.28.252")));
            sHostMaps.put("eds-aic-pre.cn-hangzhou.aliyuncs.com", Collections.singletonList(InetAddress.getByName("100.64.28.252")));
            sHostMaps.put("wyota.cn-hangzhou.aliyuncs.com", Collections.singletonList(InetAddress.getByName("100.64.28.252")));
            sHostMaps.put("pre-wuyinota.aliyuncs.com", Collections.singletonList(InetAddress.getByName("100.64.28.252")));
            sHostMaps.put("wy-app-ops-pre.aliyun.com", Collections.singletonList(InetAddress.getByName("100.64.28.252")));
        } catch (UnknownHostException e) {
            e.printStackTrace();
        }
    }

    public static void setUseCustomDns(boolean isUse) {
        sIsUseCustomDns = isUse;
    }

    @NonNull
    @Override
    public List<InetAddress> lookup(@NonNull String host) throws UnknownHostException {
        if(sIsUseCustomDns && sHostMaps.containsKey(host)) {
            Log.e("DNS", "find host dns.");
            return Objects.requireNonNull(sHostMaps.get(host));
        }

        return Dns.SYSTEM.lookup(host);
    }
}
